Package ghidra.util.datastruct

# Class SoftCacheMap<K,V>

java.lang.Object
ghidra.util.datastruct.SoftCacheMap<K,V>

All Implemented Interfaces:
  `Map<K,V>`

public class SoftCacheMap<K,V> extends Object implements Map<K,V>
Class to manage a "soft" HaspMap that keeps its keys as soft references so they can be reclaimed if needed. Useful for caching.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from interface java.util.Map

  `Map.Entry<K,V>`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SoftCacheMap(int cacheSize)`
  Constructs a new SoftCacheMap that has at most cacheSize entries.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `clear()`
  `boolean`
  `containsKey(Object key)`
  `boolean`
  `containsValue(Object value)`
  `Set<Map.Entry<K,V>>`
  `entrySet()`
  `V`
  `get(Object key)`
  `boolean`
  `isEmpty()`
  `Set<K>`
  `keySet()`
  `V`
  `put(K key, V value)`
  `void`
  `putAll(Map<? extends K,? extends V> t)`
  `V`
  `remove(Object key)`
  `int`
  `size()`
  `Collection<V>`
  `values()`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface java.util.Map

  `compute, computeIfAbsent, computeIfPresent, equals, forEach, getOrDefault, hashCode, merge, putIfAbsent, remove, replace, replace, replaceAll`

- ## Constructor Details

  - ### SoftCacheMap

    public SoftCacheMap(int cacheSize)
    Constructs a new SoftCacheMap that has at most cacheSize entries.
    Parameters:
      `cacheSize` - the max number of entries to cache.

- ## Method Details

  - ### put

    public V put(K key, V value)
    Specified by:
      `put` in interface `Map<K,V>`
    See Also:
      - `Map.put(java.lang.Object, java.lang.Object)`

  - ### get

    public V get(Object key)
    Specified by:
      `get` in interface `Map<K,V>`
    See Also:
      - `Map.get(java.lang.Object)`

  - ### size

    public int size()
    Specified by:
      `size` in interface `Map<K,V>`
    See Also:
      - `Map.size()`

  - ### clear

    public void clear()
    Specified by:
      `clear` in interface `Map<K,V>`
    See Also:
      - `Map.clear()`

  - ### isEmpty

    public boolean isEmpty()
    Specified by:
      `isEmpty` in interface `Map<K,V>`
    See Also:
      - `Map.isEmpty()`

  - ### containsKey

    public boolean containsKey(Object key)
    Specified by:
      `containsKey` in interface `Map<K,V>`
    See Also:
      - `Map.containsKey(java.lang.Object)`

  - ### containsValue

    public boolean containsValue(Object value)
    Specified by:
      `containsValue` in interface `Map<K,V>`
    See Also:
      - `Map.containsValue(java.lang.Object)`

  - ### values

    public Collection<V> values()
    Specified by:
      `values` in interface `Map<K,V>`
    See Also:
      - `Map.values()`

  - ### putAll

    public void putAll(Map<? extends K,? extends V> t)
    Specified by:
      `putAll` in interface `Map<K,V>`
    See Also:
      - `Map.putAll(java.util.Map)`

  - ### entrySet

    public Set<Map.Entry<K,V>> entrySet()
    Specified by:
      `entrySet` in interface `Map<K,V>`
    See Also:
      - `Map.entrySet()`

  - ### keySet

    public Set<K> keySet()
    Specified by:
      `keySet` in interface `Map<K,V>`
    See Also:
      - `Map.keySet()`

  - ### remove

    public V remove(Object key)
    Specified by:
      `remove` in interface `Map<K,V>`
    See Also:
      - `Map.remove(java.lang.Object)`